#
#       HBS REDUCTION SUB ROUTINE
#
#      Confirmation fitted image :  hbs1to1con.cl
#
#

procedure hbs1to1con

begin

  file fn_we, fn_wo
  file fn_se, fn_so, fn_sw

  file fnoute = "plot_e.xy"
  file fnouto = "plot_o.xy"

  int i
  real x, y
  real c0, c1, c2, c3, c4, c5, c6, c7, c8

  fn_we = envget( "_1to1we" )
  fn_wo = envget( "_1to1wo" )
  fn_se = envget( "_1to1se" )
  fn_so = envget( "_1to1so" )

  printf( "Plotting file of fitted curves\n" )

  if( access( fnoute ) == 1 )
    delete( fnoute, ver- )

  if( access( fnouto ) == 1 )
    delete( fnouto, ver- )

#--- extraordinary - X ---

  if( access( fn_we ) == 0 )
  {
    printf( "%s: Not found\n", fn_we )
    bye
  }
  list = fn_we

  for( i=1; i<=21; i+=1 )
  {
    if( fscan( list, c0, c1, c2, c3, c4, c5 ) == 6 )
    {
      for( x=0.; x<=1001.; x+=20. )
      {
        y = c0 + c1*x + c2*x**2 + c3*x**3 + c4*x**4 + c5*x**5
        printf( "%5.0f  %6.2f\n", x, y, >> fnoute )
      }
      printf( "\n", >> fnoute )
    }
  }

#--- ordinary - X ---

  if( access( fn_wo ) == 0 )
  {
    printf( "%s: Not found\n", fn_wo )
    bye
  }
  list = fn_wo

  for( i=1; i<=21; i+=1 )
  {
    if( fscan( list, c0, c1, c2, c3, c4, c5 ) == 6 )
    {
      for( x=0.; x<=1001.; x+=20. )
      {
        y = c0 + c1*x + c2*x**2 + c3*x**3 + c4*x**4 + c5*x**5
        printf( "%5.0f  %6.2f\n", x, y, >> fnouto )
      }
      printf( "\n", >> fnouto )
    }
  }


#--- extraordinary - Y ---

  if( access( fn_se ) == 0 )
  {
    printf( "%s: Not found\n", fn_se )
    bye
  }
  list = fn_se

  for( i=1; i<=25; i+=1 )
  {
    if( fscan( list, c0, c1, c2, c3 ) == 4 )
    {
      for( y=0.; y<=431.; y+=10. )
      {
        x = c0 + c1*y + c2*y**2 + c3*y**3
        printf( "%6.2f  %5.0f\n", x, y, >> fnoute )
      }
      printf( "\n", >> fnoute )
    }
  }

#--- ordinary - Y ---

  if( access( fn_so ) == 0 )
  {
    printf( "%s: Not found\n", fn_so )
    bye
  }
  list = fn_so

  for( i=1; i<=25; i+=1 )
  {
    if( fscan( list, c0, c1, c2, c3 ) == 4 )
    {
      for( y=0.; y<=431.; y+=10. )
      {
        x = c0 + c1*y + c2*y**2 + c3*y**3
        printf( "%6.2f  %5.0f\n", x, y, >> fnouto )
      }
      printf( "\n", >> fnouto )
    }
  }

end
