#
#       HBS REDUCTION SUB ROUTINE
#
#       shift and arrange spectrum reffering to specified two features
#                                            : hbsarrange.cl
#
#       1998/02/06      K.Kawabata  Ver.0.10
#       1998/04/20      K.Kawabata  Ver.2.00 unification
#       1998/05/31      K.Kawabata  Ver.2.10
#       2000/02/29      K.Kawabata  Ver.3.00 for SITe-CCD
#       2001/09/05      K.Kawabata  Ver.3.10 auto feature-identify
#

procedure hbsarrange

begin

  file fn
  string fn_stack[500]
  int n_image

  string hbslist[500]
  string shorttyp[500], title[500]
  string exptime[500], diaph[500], filter[500]
  string slit[500]
  string listoflist
  string prmfile
  int n_list
  file logfn

  string fnobe, fnobo
  string fnobes, fnobos
  string fnnexte, fnnexto
  file tmp_list, tmp_fn, tmp_tbl
  file tmp_fn1
  string buf, buf1, buf2, buf3, buf4, buf5, buf6, buf7, buf8, buf9
  string caldir, rdir, etcdir
  int c, i, j, k
  int flag_uplow  #  0:lower  1: upper  -1:other
  string fn_def
  real crpix, crval, cdelt

  file ref_fni = "hbs.ident.od"
  file ref_fnr = "hbs.refer.od"
  file shiftlog
  int dy

  file feature_fn, feature_head
  string feat_stack[20]
  int n_featfn
  real lmd10, lmd20, wid10, wid20
  real dl1, dl2, dl0
  real lmd1, lmd2
  real x1, x2, dx1, dx2, dx0
  int nx1, nx2
  string feattyp1, feattyp2, comm1, comm2
  string featmode # 1:auto(7600A) 2:manual
  int nfeat = 2

  real os, os_2HL, os_2S2, os_tmp

  int runmeanf = 200 # boxcar factor for identify
  int multiplef = 10000 # multiple factor for identify
  int fwidth1
  string fitysection = "middle line"
  real threshold1 = 0.0
  real crad1 = 30.0
  real sftthr = 400.0
  real ccreg = 5 # Region width for cross-correlation (* feature width)
  string nullfile
  real secppix, seeing
  int flag_first     # for identify-reference

  int nccd = 0       # 1:TC215 2:SITe
  int flag_erase     # 0:keep old images, 1:erase old images
  int flag_inquiry   # 1:'flag_overwrite' applys to all image
  int flag_overwrite # 0:skip 1:overwrite
  int flag_ver       # 0:no display 1:display
  int n_version      # IRAF version (210 or 211)

#--- initial settings

  logfn = envget( "_logfile" )

  if( access( "hbs.tmp.time" ) == 1 )
    delete( "hbs.tmp.time", ver- )
  time >> hbs.tmp.time
  list = "hbs.tmp.time"
  if( fscan( list, buf, buf1, buf2 ) != 3 )
  {
    printf( "Error: time task -- reading\n" )
    bye
  }
  delete( "hbs.tmp.time", ver- )

  print( "" )
  printf( "%s %s\n", buf1, buf2 )
  print( "------------------------------" )
  print( " Shift and Arrange Wavelength" )
  print( "------------------------------" )
  print( "" )

  print( "", >> logfn )
  printf( "%s %s\n", buf1, buf2, >> logfn )
  print( "------------------------------", >> logfn )
  print( " Shift and Arrange Wavelength", >> logfn )
  print( "------------------------------", >> logfn )
  print( "", >> logfn )

  listoflist = envget( "_rootlist" )
  caldir = envget( "_caldir" )
  fn_def = caldir//envget( "_defhname" )
  etcdir = envget( "_etcdir" )
  shiftlog = envget( "_xsftlog" )
  nullfile = envget( "_nullfile" )
#  secppix = real( envget( "_secppix" ) ) # deleted from SITe-CCD version
  nullfile = envget( "_nullfile" )
  feature_head = envget( "_features" )

  buf = ""
  tmp_list = mktemp( "hbs.tmp.list." )
  tmp_tbl = "hbs.tmp.fxcor"
  tmp_fn = mktemp( "hbs.tmp.image." )
  tmp_fn1 = mktemp( "hbs.tmp.image." )

  if( access( listoflist ) == 0 )
  {
    print( "Cannot find "//listoflist//". Please do hbsgroup." )
    print( "Cannot find "//listoflist//". Please do hbsgroup.", >> logfn )
    bye
  }

#  time >> shiftlog

#----- read difinition file

  buf1 = ""
  buf2 = ""
  buf3 = ""

  if( access( fn_def ) == 0 )
  {
    printf( "Cannot find '%s'\n", fn_def )
    printf( "Cannot find '%s'\n", fn_def, >> logfn )
    bye
  }

  crpix = 1.0
  crval = 0.0
  cdelt = 0.0
  os_2HL = 9999.0
  os_2S2 = 9999.0
  nccd = 1        # for old 'hbsdefine.h'

  secppix = 0.22  # from SITe-CCD version

  list = fn_def
  while( fscan( list, buf1, buf2, buf3 ) != EOF )
  {
    if( buf2 == "SW" )
    {
      crval = real( buf3 )
    }
    if( buf2 == "DW" )
    {
      cdelt = real( buf3 )
    }
    if( buf2 == "OS_2HL" )
    {
      os_2HL = real( buf3 )
    }
    if( buf2 == "OS_2S2" )
    {
      os_2S2 = real( buf3 )
    }
    if( buf2 == "NCCD" )
      nccd = int( buf3 )
    if( buf2 == "ASPPIX" )
      secppix = real( buf3 )
  }
  if( ( crval * cdelt ) == 0 || os_2HL > 5000 || os_2S2 > 5000 )
  {
    printf( "Read error in '%s'\n", fn_def )
    printf( "Read error in '%s'\n", fn_def, >> logfn )
    bye
  }

#--- Verbose Mode

  if( envget( "_fg_ver" ) == "1" )
  {
    flag_ver = 1
  }
  else
  {
    if( envget( "_fg_ver" ) == "2" )
    {
      flag_ver = 0
    }
    else
    {
      printf( "'hbsinit' process is incomplete.(_fg_ver) Retry.\n" )
      printf( "'hbsinit' process is incomplete.(_fg_ver) Retry.\n", >> logfn )
      bye
    }
  }

#----- Replace Mode

  if( envget( "_fg_mode" ) == "1" )
  {
    flag_inquiry = 1
    flag_overwrite = 1
  }
  else
  {
    if( envget( "_fg_mode" ) == "2" )
    {
      flag_inquiry = 1
      flag_overwrite = 0
    }
    else
    {
      if( envget( "_fg_mode" ) == "3" )
      {
        flag_inquiry = 0
        flag_overwrite = 0
      }
      else
      {
        printf( "'hbsinit' process is incomplete.(_fg_mode) Retry.\n" )
        printf( "'hbsinit' process is incomplete.(_fg_mode) Retry.\n",\
                >> logfn )
        bye
      }
    }
  }
    
#----- Erase/Reserve old image

  if( envget( "_fg_del2" ) == "1" )
  {
    flag_erase = 1
  }
  else
  {
    if( envget( "_fg_del2" ) == "2" )
    {
      flag_erase = 0
    }
    else
    {
      printf( "'hbsinit' process is incomplete.(_fg_del2) Retry.\n" )
      printf( "'hbsinit' process is incomplete.(_fg_del2) Retry.\n", >> logfn )
      bye
    }
  }

#----- IRAF version check

  buf1 = envget( "version" )
  c = stridx( "V", buf1 )
  buf2 = substr( buf1, c, ( c + 4 ) )

  n_version = 0

  if( buf2 == "V2.11" )
  {
    n_version = 211
  }
  else
  {
    if( buf2 == "V2.10" )
    {
      n_version = 210
    }
  }

  if( n_version == 0 )
  {
    printf( "IRAF version check failed.\n" )
    printf( "Please input like next line, and restart 'hbsred'\n" )
    printf( "cl> set version V2.10  (V2.10 and V2.11 are valid)\n" )
    printf( "IRAF version check failed.\n", >> logfn )
    printf( "Please input like next line, and restart 'hbsred'\n", >> logfn )
    printf( "cl> set version V2.10  (V2.10 and V2.11 are valid)\n", >> logfn )
    bye
  }

#----- Scanning the list file

  n_list = 0
  list = listoflist

  while( fscan(list, buf1, buf2, buf3, buf4, buf5, buf6, buf7 ) != EOF )
  {
    if( substr( buf1, 1, 3 ) != "HBS" )
    {
      print( "The list-file ", listoflist, " is not produced by HBSGROUP.CL" )
      print( "The list-file ", listoflist, " is not produced by HBSGROUP.CL",\
             >> logfn )
      break
    }
    n_list += 1
    hbslist[n_list] = buf1
    shorttyp[n_list] = buf2
    title[n_list] = buf3
    exptime[n_list] = buf4
    diaph[n_list] = buf5
    filter[n_list] = buf6
    slit[n_list] = buf7
  }

#----- main routine

  for( i=1; i<=n_list; i+=1 )
  {
    if( shorttyp[i] != "DAR" && shorttyp[i] != "BIA" &&\
        shorttyp[i] != "NEA" )
    {
      flag_first = 1

      prmfile = hbslist[i]//".prm"

#----- check diaphragm

      rdir = "none"
      os = 9999.0

      if( substr( diaph[i], 1, 3 ) == "2HL" )
      {
	rdir = caldir
	os = os_2HL
      }
      if( substr( diaph[i], 1, 3 ) == "2S2" )
      {
	rdir = caldir
	os = os_2S2
      }

      if( rdir == "none" || os > 5000.0 )
      {
        printf( "\nUnknown Diaph type in %s (%s)\n", hbslist[i], diaph[i] )
        printf( "\nUnknown Diaph type in %s (%s)\n", hbslist[i], diaph[i],\
                >> logfn )
	next
      }

      if( substr( diaph[i], 4, 4 ) == "L" )
      {
        flag_uplow = 0
        printf( "\n--- OBJECT LIST : %s  LOWER ---\n", hbslist[i] )
        printf( "\n--- OBJECT LIST : %s  LOWER ---\n", hbslist[i], >> logfn )
      }
      else
      {
        if( substr( diaph[i], 4, 4 ) == "U" )
        {
          flag_uplow = 1
          printf( "\n--- OBJECT LIST : %s  UPPER ---\n", hbslist[i] )
          printf( "\n--- OBJECT LIST : %s  UPPER ---\n", hbslist[i], >> logfn )
        }
        else
        {
#         flag_uplow = -1
          printf( "\n%s did not uset two diaphragm mode\n", hbslist[i] )
          printf( "\n%s did not uset two diaphragm mode\n", hbslist[i],\
                  >> logfn )
	  next
        }
      }

#----- read identify mode

      list = prmfile
      if( fscan( list, buf, buf, buf, buf, buf, buf, buf, featmode ) != 8 )
      {
        printf( "Read error in '%s'\n", prmfile )
        printf( "Read error in '%s'\n", prmfile, >> logfn )
        bye
      }

#----- choose OBJ spectra

      sed( 's/fit\.imh//', hbslist[i], > tmp_list )

      list = tmp_list
      n_image = 0
      while( fscan( list, buf ) != EOF )
      {
        n_image += 1
        fn_stack[n_image] = buf
      }
      delete( tmp_list, ver- )

      for( j=1; j<=n_image; j+=1 )
      {
        fn = fn_stack[j]

        if( flag_uplow == 0 )
        {
          fnobe = fn//"sk.3"
          fnobo = fn//"sk.4"
          fnobes = fn//"sf.3"
          fnobos = fn//"sf.4"

          if( j < n_image )
	  {
            fnnexte = fn_stack[j+1]//"sf.3"
            fnnexto = fn_stack[j+1]//"sf.4"
	  }
	  else
	  {
            fnnexte = "none"
            fnnexto = "none"
	  }
        }
        else
        {
          fnobe = fn//"sk.1"
          fnobo = fn//"sk.2"
          fnobes = fn//"sf.1"
          fnobos = fn//"sf.2"

          if( j < n_image )
	  {
            fnnexte = fn_stack[j+1]//"sf.1"
            fnnexto = fn_stack[j+1]//"sf.2"
	  }
	  else
	  {
            fnnexte = "none"
            fnnexto = "none"
	  }
        }

        if( access( fnobe//".imh" ) == 0 ||\
            access( fnobo//".imh" ) == 0 )
        {
          printf( "%s--(not exist. skip.)  ", fn )
          printf( "%s--(not exist. skip.)  ", fn, >> logfn )
          next
        }

        if( access( fnobes//".imh" ) == 1 || access( fnobos//".imh" ) == 1 )
        {
          if( flag_overwrite == 0 )
          {
            if( fnnexte != "none" && ( access( fnnexte//".imh" ) == 0 ||\
	        access( fnnexto//".imh" ) == 0 ) )
            {
	      printf( "\n%s: Maybe insufficient proccess last time.\n", fn )
              goto Inquiry
            }

            if( flag_inquiry == 1 )
            {
              if( flag_ver == 1 )
                printf( "%s--(already exists. skip.)  ", fn )
              printf( "%s--(already exists. skip.)  ", fn, >> logfn )
              next
            }
            else
	    {
              printf( "\n%s already exist.\n", fn )
              printf( "\n%s already exist.\n", fn, >> logfn )
          Inquiry:
              printf( "Overwrite? (apply-this-image-only:[y/n], all:[Y/N]) >> " )
              printf( "Overwrite? (apply-this-image-only:[y/n], all:[Y/N]) >> ", >> logfn )
              c = scan( buf )
              while( buf != "Y" && buf != "y" && buf != "n" && buf != "N" )
                c = scan( buf )
              printf( "%s\n", buf, >> logfn )
              if( buf == "Y" )
              {
                flag_inquiry = 1
                flag_overwrite = 1
              }
              if( buf == "N" )
              {
                flag_inquiry = 1
                flag_overwrite = 0
                if( flag_ver == 1 )
                  printf( "%s--(already exists. skip.)  ", fn )
                printf( "%s--(already exists. skip.)  ", fn, >> logfn )
                next
              }
              if( buf == "n" )
              {
                if( flag_ver == 1 )
                  printf( "%s--(already exists. skip.)  ", fn )
                printf( "%s--(already exists. skip.)  ", fn, >> logfn )
                next
              }
            }
          }
          if( flag_ver == 1 )
            printf( "%s(overwrite)  ", fn )
          printf( "%s(overwrite)  ", fn, >> logfn )
        }
        else
        {
          if( flag_ver == 1 )
            printf( "%s  ", fn )
          printf( "%s  ", fn, >> logfn )
        }

#----- shift width

  #----- Identify reference frame (only at first of each group)

        if( flag_first == 1 )
	{
	  flag_first = 0

          if( featmode == "1" )
	  {
            feature_fn = envget( "_featuren" )  # TI feature
	  }
          else
	  {
            if( access( ref_fni//".imh" ) == 1 &&\
	        access( "database/id"//ref_fni ) == 1 )
	    {
	      printf( "Use previous identification? [y/n] >> " )
	      printf( "Use previous identification? [y/n] >> ", >> logfn )
	      c = scan( buf )
	      while( buf != "n" && buf != "y" )
                c = scan( buf )
              printf( "%s\n", buf, >> logfn )
	      if( buf == "y" )
	        goto target
	    }
	  }

          if( access( ref_fni//".imh" ) == 1 )
            imdelete( ref_fni, ver- )
          if( access( ref_fnr//".imh" ) == 1 )
            imdelete( ref_fnr, ver- )
          if( access( "database/id"//ref_fni ) == 1 )
            delete( "database/id"//ref_fni, ver- )

          if( access( tmp_fn//".imh" ) == 1 )
	    imdelete( tmp_fn, ver- )

	  os_tmp = -1.0 * os
	  if( abs( os_tmp ) > 0.1 )
	  {
            hbsshift( fnobo, tmp_fn, os_tmp, 0.0 )
	  }
	  else
	  {
	    imcopy( fnobo, tmp_fn, ver- )
	  }

          imarith( fnobe, "+", tmp_fn, ref_fnr, pixtype="real",\
                   calctype="real", ver- )
          imdelete( tmp_fn, ver- )
          imgets( ref_fnr, 'i_naxis2' )
          dy = int( imgets.value )
          blkavg( ref_fnr, ref_fnr, 1, dy, option="sum" )
          boxcar( ref_fnr, tmp_fn1, runmeanf, 1, boundary="nearest" )
          imarith( ref_fnr, "/", tmp_fn1, ref_fni, pixtype="real",\
                   calctype="real", ver- )
          imdelete( tmp_fn1, ver- )
          imarith( ref_fni, "*", multiplef, ref_fni, pixtype="real",\
                   calctype="real", ver- )
	  imreplace( ref_fni, 0.0, upper=0.0 )
          hedit( ref_fni, "CTYPE1", "X pixel", add+, delete-, verify-,\
                 show-, update+ )

#          printf( "Now plotting reference spectrum...\n" )
          buf = "First frame of "//hbslist[i]
          prow( ref_fni, 1, wcs="physical", ylabel="ADU", xlabel=buf, fill+ )


selectftype:

          if( featmode != "1" )
	  {
	  
	    printf( "Feature type [n]:normal [b]:Balmer em. [u]:user def. >> " )
	    printf( "Feature type [n]:normal [b]:Balmer em. [u]:user def. >> ",\
                    >> logfn )
            c = scan( buf )
	    while( buf != "n" && buf != "t" && buf != "b" && buf != "u" )
              c = scan( buf )
            printf( "%s\n", buf, >> logfn )
	    if( buf == "n" )
	      feature_fn = envget( "_featuren" )
	    if( buf == "t" )
	      feature_fn = envget( "_featuret" )
	    if( buf == "b" )
	      feature_fn = envget( "_featureb" )
	    if( buf == "u" )
	    {
	      chdir _etcdir$
	      sections( feature_head, option="fullname", > tmp_list )
	      n_featfn = 0
	      list = tmp_list
	      while( fscan( list, buf ) == 1 )
	      {
	        n_featfn += 1
	        feat_stack[n_featfn] = buf
	      }
	      delete( tmp_list, ver- )
	      back
	      if( n_featfn == 0 )
	      {
	        printf( "Feature file '%s' not found.\n", feature_head )
	        printf( "Feature file '%s' not found.\n", feature_head,\
                        >> logfn )
	        goto selectftype
	      }
	      printf( "These files detected in %s...\n", etcdir )
	      printf( "These files detected in %s...\n", etcdir, >> logfn )
	      for( k=1; k<=n_featfn; k+=1 )
	      {
	        printf( "%2d  %s\n", k, feat_stack[k] )
	        printf( "%2d  %s\n", k, feat_stack[k], >> logfn )
	      }
	      printf( "Select feature table [1-%d] >> ", n_featfn )
	      printf( "Select feature table [1-%d] >> ", n_featfn, >> logfn )
	      while( scan( buf ) != 1 ){}
	      feature_fn = etcdir//feat_stack[int( buf )]
	    }
	  }

	  #-- read feature file

	  comm1 = ""
	  comm2 = ""
	  list = feature_fn
	  if( fscan( list, feattyp1, lmd10, wid10, comm1 ) != 4 )
	  {
	    printf( "Read error '%s'\n", feature_fn )
	    printf( "Read error '%s'\n", feature_fn, >> logfn )
	    bye
	  }

	  if( fscan( list, feattyp2, lmd20, wid20, comm2 ) != 4 )
	  {
	    nfeat = 1
#	    printf( "One feature registed.\n" )
#	    printf( " 1: %s %7.2f %6.2f %s\n", feattyp1, lmd10, wid10, comm1 )
	  }
	  else
	  {
	    nfeat = 2
#	    printf( "Two features registed.\n" )
#	    printf( " 1: %s %7.2f %6.2f %s\n", feattyp1, lmd10, wid10, comm1 )
#	    printf( " 1: %s %7.2f %6.2f %s\n", feattyp2, lmd20, wid20, comm2 )
	  }

	  if( feattyp1 == "e" )
	    feattyp1 = "emission"
	  if( feattyp1 == "a" )
	    feattyp1 = "absorption"
	  if( feattyp2 == "e" )
	    feattyp2 = "emission"
	  if( feattyp2 == "a" )
	    feattyp2 = "absorption"


	#--- TI CCD feature avoid
	    
	  if( nccd == 2 && feature_fn == envget( "_featuren" ) )
	  {
	    nfeat = 1
            lmd10 = lmd20
	    wid10 = wid20
	    comm1 = comm2
	    feattyp1 = feattyp2
	  }

	#-- first feature

          fwidth1 = wid10 / cdelt
	  x1 = ( lmd10 - crval ) / cdelt + crpix

          if( featmode == "1" )
	  {
	    printf( "\n" )
            if( access( tmp_tbl ) == 1 )
	      delete( tmp_tbl, ver- )
	    if( access( tmp_fn//".imh" ) == 1 )
	      imdelete( tmp_fn, ver- )
	    if( access( "database" ) == 0 )
	      mkdir( "database" )
	    if( access( "database/id"//tmp_fn ) == 1 )
	      delete( "database/id"//tmp_fn, ver- )

            imcopy( ref_fni, tmp_fn, ver- )
	    imreplace( tmp_fn, 0.0, lower=INDEF, upper=INDEF )
	    printf( "begin   identify %s - Ap 1\n", tmp_fn,\
	            > "./database/id"//tmp_fn )
	    printf( "        id      %s\n", tmp_fn,\
	            >> "./database/id"//tmp_fn )
	    printf( "        task    identify\n",\
	            >> "./database/id"//tmp_fn )
	    printf( "        image   %s Ap - 1\n", tmp_fn,\
	            >> "./database/id"//tmp_fn )
	    printf( "        units   angstroms\n",\
	            >> "./database/id"//tmp_fn )
	    printf( "        features        1\n",\
	            >> "./database/id"//tmp_fn )
            if( feattyp1 == "absorption" )
	      buf = "2"
	    else
	      buf = "1"
	    printf( "               %7.2f%11.6f     %6.1f %5.1f %1d %1d %6.1f\n",\
	             x1, x1, x1, fwidth1, buf, 1, lmd10,\
	            >> "./database/id"//tmp_fn )

	    printf( "%5.1f   %7.2f\n",  x1, lmd10, >> tmp_tbl )

            reidentify(	tmp_fn, ref_fni, interactive-, newaps-,\
	                override+, refit-, trace-, match=-crad1,\
			coordlist=tmp_tbl,\
                        maxfeat=1, cradius=crad1, mode="ql",\
			threshold=threshold1, database="database", ver- )

	    imdelete( tmp_fn, ver- )
            delete( "database/id"//tmp_fn, ver- )
	    delete( tmp_tbl, ver- )

	  }
	  else
	  {
	    printf( "Mark with 'm' near %s feature at X=%3.0f of %2.0f width\n",\
	            feattyp1, x1, fwidth1 )
	    printf( "Mark with 'm' near %s feature at X=%3.0f of %2.0f width\n",\
	            feattyp1, x1, fwidth1, >> logfn )
            if( n_version == 210 )
	    {
              identify( ref_fni, section=fitysection, databas="database",\
                        coordli=nullfile, nsum=1, match=30.,\
                        maxfeat=1, fwidth=fwidth1, cradius=crad1,\
	                functio="legendre", order=2, niterate=1,\
	                low_rej=3., high_rej=3., grow=0., ftype=feattyp1,\
		        mode="ql", threshold=threshold1, autowrite+ )
            }
	    else
	    {
              if( n_version == 211 )
	      {
                identify( ref_fni, section=fitysection, databas="database",\
                          coordli=nullfile, nsum=1, match=30.,\
			  units="angstroms",\
                          maxfeat=1, fwidth=fwidth1, cradius=crad1,\
	                  functio="legendre", order=2, niterate=1,\
		          low_rej=3., high_rej=3., grow=0., ftype=feattyp1,\
		          mode="ql", threshold=threshold1, autowrite+ )
              }
	      else
	      {
                printf( "IRAF version erorr (%d)\n", n_version )
                printf( "IRAF version erorr (%d)\n", n_version, >> logfn )
                bye
	      }
	    }
	  }
	  if( access( "database/id"//ref_fni ) == 0 )
	  {
	    printf( "First feature   Identification error!!! Retry manually...\n" )
            featmode = "2"
	    goto selectftype
	  }

          list = "database/id"//ref_fni
          c = fscan( list, buf, buf, buf, buf, buf, buf )
          c = fscan( list, buf, buf, buf, buf, buf, buf )
          while( fscan( list, buf1, buf2, buf3, buf, buf, buf ) != 6 ){}
          x1 = real( buf1 )
          lmd1 = crval + ( x1 - crpix ) * cdelt
	  dl1 = lmd1 - lmd10
	  dx1 = dl1 / cdelt
          printf( "First feature   Read: %7.2fA = %6.2fpix  Diff:%7.2fA = %5.2fpix\n",\
	          lmd1, x1, dl1, dx1 )
          printf( "First feature   Read: %7.2fA = %6.2fpix  Diff:%7.2fA = %5.2fpix\n",\
	          lmd1, x1, dl1, dx1, >> logfn )
          delete( "database/id"//ref_fni, ver- )

          if( nfeat == 2 )
          {

	#-- second feature

            fwidth1 = wid20 / cdelt
	    x2 = ( lmd20 - crval ) / cdelt + crpix

            if( featmode == "1" )
	    {
              if( access( tmp_tbl ) == 1 )
	        delete( tmp_tbl, ver- )
	      if( access( tmp_fn//".imh" ) == 1 )
	        imdelete( tmp_fn, ver- )
	      if( access( "database" ) == 0 )
	        mkdir( "database" )
	      if( access( "database/id"//tmp_fn ) == 1 )
	        delete( "database/id"//tmp_fn, ver- )

              imcopy( ref_fni, tmp_fn, ver- )
	      imreplace( tmp_fn, 0.0, lower=INDEF, upper=INDEF )
	      printf( "begin   identify %s - Ap 1\n", tmp_fn,\
	              > "./database/id"//tmp_fn )
	      printf( "        id      %s\n", tmp_fn,\
	              >> "./database/id"//tmp_fn )
	      printf( "        task    identify\n",\
	              >> "./database/id"//tmp_fn )
	      printf( "        image   %s - Ap 1\n", tmp_fn,\
	              >> "./database/id"//tmp_fn )
	      printf( "        units   angstroms\n",\
	              >> "./database/id"//tmp_fn )
	      printf( "        features        1\n",\
	              >> "./database/id"//tmp_fn )
              if( feattyp2 == "absorption" )
	        buf = "2"
	      else
	        buf = "1"
	      printf( "               %7.2f%11.6f     %6.1f %5.1f %1d %1d %6.1f\n",\
	               x2, x2, x2, fwidth1, buf, 1, lmd20,\
	            >> "./database/id"//tmp_fn )

	      printf( "%5.1f   %7.2f\n",  x2, lmd20, >> tmp_tbl )

              reidentify( tmp_fn, ref_fni, interactive-, newaps-,\
	                  override+, refit-, trace-, match=-crad1,\
		          coordlist=tmp_tbl,\
                          maxfeat=1, cradius=crad1, mode="ql",\
			  threshold=threshold1, database="database", ver- )

	      imdelete( tmp_fn, ver- )
              delete( "database/id"//tmp_fn, ver- )
	      delete( tmp_tbl, ver- )

	    }
	    else
	    {
	      printf( "Mark with 'm' near %s feature at X=%3.0f of %2.0f width\n",\
	              feattyp2, x2, fwidth1 )
	      printf( "Mark with 'm' near %s feature at X=%3.0f of %2.0f width\n",\
	              feattyp2, x2, fwidth1, >> logfn )

              if( n_version == 210 )
	      {
                identify( ref_fni, section=fitysection, databas="database",\
                          coordli=nullfile, nsum=1, match=30.,\
                          maxfeat=1, fwidth=fwidth1, cradius=crad1,\
	                  functio="legendre", order=2, niterate=1,\
		          low_rej=3., high_rej=3., grow=0., ftype=feattyp2,\
		          mode="ql", threshold=threshold1, autowrite+ )
              }
	      else
	      {
                if( n_version == 211 )
                {
                  identify( ref_fni, section=fitysection, databas="database",\
	                    units="angstroms",\
                            coordli=nullfile, nsum=1, match=30., units="",\
                            maxfeat=1, fwidth=fwidth1, cradius=crad1,\
		            functio="legendre", order=2, niterate=1,\
		            low_rej=3., high_rej=3., grow=0., ftype=feattyp2,\
		            mode="ql", threshold=threshold1, autowrite+ )
                }
	        else
	        {
                  printf( "IRAF version erorr (%d)\n", n_version )
                  printf( "IRAF version erorr (%d)\n", n_version, >> logfn )
                  bye
	        }
	      }
	    }
	    if( access( "database/id"//ref_fni ) == 0 )
	    {
	      printf( "Second feature  Identification error!!!  Retry manually...\n" )
	      featmode = "2"
	      goto selectftype
	    }

            list = "database/id"//ref_fni
            c = fscan( list, buf, buf, buf, buf, buf, buf )
            c = fscan( list, buf, buf, buf, buf, buf, buf )
            while( fscan( list, buf1, buf2, buf3, buf, buf, buf ) != 6 ){}
            x2 = real( buf1 )
            lmd2 = crval + ( x2 - crpix ) * cdelt
	    dl2 = lmd2 - lmd20
	    dx2 = dl2 / cdelt
            printf( "First feature   Read: %7.2fA = %6.2fpix  Diff:%7.2fA = %5.2fpix\n",\
	            lmd2, x2, dl2, dx2 )
            printf( "First feature   Read: %7.2fA = %6.2fpix  Diff:%7.2fA = %5.2fpix\n",\
	            lmd2, x2, dl2, dx2, >> logfn )

            delete( "database/id"//ref_fni, ver- )

            dx0 = ( dx1 + dx2 ) / 2.0

	    if( abs( dx1 - dx2 ) < 7.0 )
	    {
	      printf( "Average = %5.2fpixels\n", dx0 )
	      printf( "Average = %5.2fpixels\n", dx0, >> logfn )
 	    }
	    else
	    {
	      printf( "Difference(=%5.2fpix) is not negligible. Maybe failure.\n",\
	            abs( dx1 - dx2 ) )
	      printf( "Difference(=%5.2fpix) is not negligible. Maybe failure.\n",\
	            abs( dx1 - dx2 ), >> logfn )
              printf( "[1]:Select feature type again [2]:manual input of shift value >> " )
	      printf( "[1]:Select feature type again [2]:manual input of shift value >> ", >> logfn )
              c = scan( buf )
	      while( buf != "1" && buf != "2" )
                c = scan( buf )
              printf( "%s\n", buf, >> logfn )
	      if( buf == "1" )
	        goto selectftype

	      printf( "Manual number input around %6.2f (pix) >> ", dx0 )
	      printf( "Manual number input around %6.2f (pix) >> ",\
                      dx0, >> logfn )
	      c  = scan( dx0 )
	      printf( "Input value = %5.2fpixels\n", dx0 )
	      printf( "Input value = %5.2fpixels\n", dx0, >> logfn )
	    }
	  }
	  else
	  {
	    dx0 = dx1

	    if( abs( dx0 ) > 40.0 )
	    {
	      printf( "Shift value (=%5.2fpix) is large. Maybe failure.\n",\
	              dx0 )
	      printf( "Shift value (=%5.2fpix) is large. Maybe failure.\n",\
	                dx0, >> logfn )

	      printf( "[1]:Select feature type again [2]:manual input of shift value >> " )
	      printf( "[1]:Select feature type again [2]:manual input of shift value >> ", >> logfn )
              c = scan( buf )
	      while( buf != "1" && buf != "2" )
                c = scan( buf )
              printf( "%s\n", buf, >> logfn )
	      if( buf == "1" )
	        goto selectftype

	      printf( "Manual number input (pix) >> " )
	      printf( "Manual number input (pix) >> ", >> logfn )
	      c  = scan( dx0 )
	      printf( "Input value = %5.2fpixels\n", dx0 )
	      printf( "Input value = %5.2fpixels\n", dx0, >> logfn )
	    }
	  }

# Window of cross-correlation

          if( featmode == "1" )
	  {
            if( nfeat == 2 )
	    {
	      fwidth1 = wid20 / cdelt
	    }
	    else
	    {
	      fwidth1 = wid10 / cdelt
            }
            nx1 = x1 - 0.5 * min( ( ccreg * fwidth1 ), 200.0 )
            nx2 = x1 + 0.5 * min( ( ccreg * fwidth1 ), 200.0 )
	  }
          else
	  {
	
#            imgets( tmp_fn, 'i_naxis1' )
#            nx1 = 0.15 * int( imgets.value )
#            nx2 = 0.85 * int( imgets.value )

            if( nfeat == 2 )
            {
              printf( "Feature 1: lambda=%7.2fA X=%6.2fpix\n", lmd1, x1 )
              printf( "Feature 2: lambda=%7.2fA X=%6.2fpix\n", lmd2, x2 )
              printf( "Feature 1: lambda=%7.2fA X=%6.2fpix\n", lmd1, x1, >> logfn )
              printf( "Feature 2: lambda=%7.2fA X=%6.2fpix\n", lmd2, x2, >> logfn )
	      printf( "Which is to be used in cross-correlation [1] or [2] >> " )
	      printf( "Which is to be used in cross-correlation [1] or [2] >> ", >> logfn )
              c = scan( buf )
              while( buf != "1" && buf != "2" )
                c = scan( buf )
	      printf( "%s\n", buf, >> logfn )
	      if( buf == "1" )
	      {
                fwidth1 = wid10 / cdelt
	        nx1 = x1 - 0.5 * min( ( ccreg * fwidth1 ), 200.0 )
	        nx2 = x1 + 0.5 * min( ( ccreg * fwidth1 ), 200.0 )
	      }
	      else
	      {
                fwidth1 = wid20 / cdelt
	        nx1 = x2 - 0.5 * min( ( ccreg * fwidth1 ), 200.0 )
	        nx2 = x2 + 0.5 * min( ( ccreg * fwidth1 ), 200.0 )
	      }
            }
	    else
	    {
              fwidth1 = wid10 / cdelt
	      nx1 = x1 - 0.5 * min( ( ccreg * fwidth1 ), 200.0 )
	      nx2 = x1 + 0.5 * min( ( ccreg * fwidth1 ), 200.0 )
	    }
	  }
          printf( "Correlation window: %6.2f-%6.2f\n", nx1, nx2 )	  
          printf( "Correlation window: %6.2f-%6.2f\n", nx1, nx2, >> logfn )
	}

  #----- target frame (automatic cross-correlation)

  target:
        if( access( tmp_tbl//".txt" ) == 1 )
	   delete( tmp_tbl//".txt", ver- )
        if( access( tmp_fn1//".imh" ) == 1 )
	  imdelete( tmp_fn1, ver- )

	os_tmp = -1.0 * os
	if( abs( os_tmp ) > 0.1 )
	{
          hbsshift( fnobo, tmp_fn1, os_tmp, 0.0 )
	}
	else
	{
	  imcopy( fnobo, tmp_fn1, ver- )
	}

        imarith( fnobe, "+", tmp_fn1, tmp_fn, pixtype="real",\
                 calctype="real", ver- )
        imdelete( tmp_fn1, ver- )
        imgets( tmp_fn, 'i_naxis2' )
        dy = int( imgets.value )
        blkavg( tmp_fn, tmp_fn, 1, dy, option="sum" )
        hbscoord( tmp_fn )

	
#        fxcor( tmp_fn, ref_fnr, continuum="none", filter="none",\
#	       pixcorr+, osample=nx1//":"//nx2, rsample=nx1//":"//nx2,\
#	       function="gaussian", apertures="*", cursor="",\
#	       width=21.0, weights=1.0, background=0.0, window=INDEF,\
#	       wincenter=INDEF, output=tmp_tbl, verbose="stxtonly",\
#	       imupdate-, interactive-, autodraw+ )
        fxcor( tmp_fn, ref_fnr,\
	       pixcorr+, osample=nx1//":"//nx2, rsample=nx1//":"//nx2,\
	       function="gaussian", weights=1.0,\
	       width=21.0, output=tmp_tbl, verbose="stxtonly",\
	       interactive- )

        if( access( tmp_tbl//".txt" ) == 0 )
        {
          printf( "Error in fxcor text1 for %s\n", fn )
          printf( "Error in fxcor text1 for %s\n", fn, >> logfn )
	  bye
        }
        list = tmp_tbl//".txt"
        c = fscan( list, buf1, buf2, buf3, buf4, buf5, buf6,\
	           buf7, buf8, buf9 )
	while( substr( buf1, 1, 1 ) == "#" )
	{
          c = fscan( list, buf1, buf2, buf3, buf4, buf5, buf6,\
	             buf7, buf8, buf9 )
        }
	if( c != 9 )
        {
          printf( "Error in fxcor text2 for %s\n", fn )
          printf( "Error in fxcor text2 for %s\n", fn, >> logfn )
	  bye
        }
        dx1 = real( buf6 )
	dx2 = dx0 + dx1
        printf( "%6.2f %6.2f %6.2f\n", dx0, dx1, dx2 )
        printf( "%s %6.2f %6.2f %6.2f\n", fn, dx0, dx1, dx2, >> shiftlog )
        printf( "%s %6.2f %6.2f %6.2f\n", fn, dx0, dx1, dx2, >> logfn )
        imdelete( tmp_fn, ver- )
        delete( tmp_tbl//".txt", ver- )

#---- Shift

	if( access( fnobes//".imh" ) == 1 )
	  imdelete( fnobes, ver- )

	os_tmp = -1.0 * dx2
        if( abs( os_tmp * cdelt ) > sftthr )
        {
          printf( "Too large shift length. Skipped.\n" )
          printf( "Too large shift length. Skipped.\n", >> logfn )
          next
        }
	if( abs( os_tmp ) > 0.1 )
	{
          hbsshift( fnobe, fnobes, os_tmp, 0.0 )
	}
	else
	{
	  imcopy( fnobe, fnobes, ver- )
	}

	if( access( fnobes//".imh" ) == 0 )
	{
	  printf( "Shift failed. Abnormal end.\n" )
	  printf( "Shift failed. Abnormal end.\n", >> logfn )
	  bye
	}
        hbscoord( fnobes )

	if( access( fnobos//".imh" ) == 1 )
	  imdelete( fnobos, ver- )

	os_tmp = -1.0 * ( dx2 + os )
        if( abs( os_tmp * cdelt ) > sftthr )
        {
          printf( "Too large shift length. Skipped.\n" )
          printf( "Too large shift length. Skipped.\n", >> logfn )
          imdelete( fnobes, ver- )
          next
        }
	if( abs( os_tmp ) > 0.1 )
        {
	  hbsshift( fnobo, fnobos, os_tmp, 0.0 )
	}
	else
	{
	  imcopy( fnobo, fnobos, ver- )
	}

	if( access( fnobos//".imh" ) == 0 )
	{
	  printf( "Shift failed. Abnormal end.\n" )
	  printf( "Shift failed. Abnormal end.\n", >> logfn )
	  bye
	}
        hbscoord( fnobos )

#---- FITS header comments

        hedit( fnobes, "CRPIX1", crpix, add+, delete-, verify-, show-,\
               update+ )
        hedit( fnobes, "CRVAL1", crval, add+, delete-, verify-, show-,\
               update+ )
        hedit( fnobes, "CD1_1", cdelt, add+, delete-, verify-, show-,\
               update+ )
        hedit( fnobes, "CDELT1", cdelt, add+, delete-, verify-, show-,\
               update+ )

        hedit( fnobos, "CRPIX1", crpix, add+, delete-, verify-, show-,\
               update+ )
        hedit( fnobos, "CRVAL1", crval, add+, delete-, verify-, show-,\
               update+ )
        hedit( fnobos, "CD1_1", cdelt, add+, delete-, verify-, show-,\
               update+ )
        hedit( fnobos, "CDELT1", cdelt, add+, delete-, verify-, show-,\
               update+ )

	if( flag_erase == 1 )
	{
          imdelete( fnobe, ver- )
          imdelete( fnobo, ver- )
	}
      }
      if( access( ref_fni//".imh" ) == 1 )
        imdelete( ref_fni, ver- )
      if( access( ref_fnr//".imh" ) == 1 )
        imdelete( ref_fnr, ver- )
      if( access( "database/id"//ref_fni ) == 1 )
        delete( "database/id"//ref_fni, ver- )
    }
  }

end
