#
#       HBS REDUCTION SUB ROUTINE
#
#       averaging and subtracting near-by sky : hbenssub1.cl
#
#       1997/01/16      K.Kawabata ver.0.10
#
#
#    Files in the list must be ordered like following
#
#       sky1
#       object1
#       sky1
#       object1
#       sky1
#       sky2
#       object2
#       sky2
#       object2
#       sky2
#       sky3
#         :
#         :
#
procedure hbsnssub1( inlist )

file inlist	{ prompt = "Input grouped list to be proccessed" }


begin

  file hbslist, fn
  int n_image
  string fnstack[200]

  file tmp_list1, tmp_fn1, tmp_fn2
  string buf1, buf2, buf3, buf4, buf5
  int i, j, n
  string obj_image1, obj_image2

  tmp_list1 = mktemp( "hbs.tmp.list." )
  tmp_fn1 = mktemp( "hbs.tmp.image." )
  tmp_fn2 = mktemp( "hbs.tmp.image." )

  hbslist = inlist

  sed( 's/fit\.imh//', hbslist, > tmp_list1 )

  n_image = 0
  list = tmp_list1
  while( fscan( list, fn ) != EOF ){
    n_image += 1
    fnstack[n_image] = fn
  }

  for( j=1; j<=n_image; j+=5 )
  {
    buf1 = fnstack[j]//"fit"
    buf2 = fnstack[j+1]//"fit"
    obj_image1 = fnstack[j+1]//"d"
    buf3 = fnstack[j+2]//"fit"
    buf4 = fnstack[j+3]//"fit"
    obj_image2 = fnstack[j+3]//"d"
    buf5 = fnstack[j+4]//"fit"

#----- 

    imarith( buf1, "+", buf3, tmp_fn1, pixtype="real",\
             calctype="real", ver- )
    imarith( tmp_fn1, "/", "2.0", tmp_fn1, pixtype="real",\
             calctype="real", ver- )
    imarith( buf2, "-", tmp_fn1, obj_image1,\
             pixtype="real", calctype="real", ver- )

    imarith( buf3, "+", buf5, tmp_fn2, pixtype="real",\
             calctype="real", ver- )
    imarith( tmp_fn2, "/", "2.0", tmp_fn2, pixtype="real",\
             calctype="real", ver- )
    imarith( buf4, "-", tmp_fn2, obj_image2,\
             pixtype="real", calctype="real", ver- )

    imdelete( tmp_fn1, ver- )
    imdelete( tmp_fn2, ver- )

  }

  delete( tmp_list1, ver- )

end
