#
#       HBS REDUCTION SUB ROUTINE
#
#       Averaging all 1o2 file of UP standards : hbsupeooave.cl
#
#       1997/03/31      K.Kawabata Ver.0.10 for CRYOCAM manual reduc
#
#

procedure hbsupeooave( inlist )

file inlist	{ prompt = "Input grouped list to be proccessed" }

begin

  file hbslist
  file fn
  file tmp_list1, tmp_list2
  string tmp_listl[16], tmp_listu[16], out_fnl[16], out_fnu[16]
  int c, i
  int flagl[16], flagu[16], flag_exist
  real theta
  string buf1, buf2
  string diaph
  real rsigma = 2.0

  hbslist = inlist
  tmp_list1 = mktemp( "hbs.tmp.list." )
  flag_exist = 0
  for( i=1; i<=16; i+=1 ){
    flagl[i] = 0
    flagu[i] = 0
    tmp_listl[i] = mktemp( "hbs.tmp.list." )
    tmp_listu[i] = mktemp( "hbs.tmp.list." )
    out_fnl[i] = "upavel"//(i-1)//".eoo.imh"
    out_fnu[i] = "upaveu"//(i-1)//".eoo.imh"
    if( access( out_fnl[i] ) || access( out_fnu[i] ) )
      flag_exist += 1
  }

  buf1 = "y"
  if( flag_exist != 0 )
  {
    print( "upave*.1o2.imh already exist. delete them? ([y]=default / [n])" )
    i = scan( buf1 )
    while( i != 0 && buf1 != "y" && buf1 != "n" )
      i = scan( buf1 )
    if( buf1 == "n" )
      bye
    imdelete( "upave*.1o2.imh", ver- )
  }

#  sections( "u*.1o2.imh", option="fullname", > tmp_list1 )
  sed( 's/\.fit\./\.bn\.eoo\./', hbslist, > tmp_list1 )

#----- sort by its POS-HWP value

  list = tmp_list1

  while( fscan( list, fn ) != EOF )
  {
    imgets( fn, "POS-HWP" )
    theta = real( imgets.value )
    i = int( theta / 22.499 ) + 1

    imgets( fn, 'DIAPHRAG' )
    diaph = imgets.value
    c = strlen( diaph )
    if( substr( diaph, (c-4), c ) == "LOWER" )
    {
      tmp_list2 = tmp_listl[i]
      flagl[i] = flagl[i] + 1
    }
    if( substr( diaph, (c-4), c ) == "UPPER" )
    {
      tmp_list2 = tmp_listu[i]
      flagu[i] = flagu[i] + 1
    }
    print( fn, >> tmp_list2 )
  }

#----- averaging

  for( i=1; i<=16; i+=1 ){
    if( flagl[i] > 3 )
    {
      imcombine( input="@"//tmp_listl[i], output=out_fnl[i],\
                 combine="average",\
                 reject="avsigclip", mclip+, project-, outtype="real",\
                 offsets="none", masktype="none", scale="none",\
                 zero="none", weight="none", lthreshold=INDEF,\
                 hthreshold=INDEF, nlow=1, nhigh=1,\
		 lsigma=rsigma, hsigma=rsigma )
    }
    else
    {
      if( flagl[i] > 0 )
        imcombine( input="@"//tmp_listl[i], output=out_fnl[i],\
	           combine="average",\
                   reject="none", project-, outtype="real",\
                   offsets="none", masktype="none", lthreshold=INDEF,\
                   hthreshold=INDEF, nlow=1, nhigh=1 )
    }
    if( flagu[i] > 3 )
    {
      imcombine( input="@"//tmp_listu[i], output=out_fnu[i],\
                 combine="average",\
                 reject="avsigclip", mclip+, project-, outtype="real",\
                 offsets="none", masktype="none", scale="none",\
                 zero="none", weight="none", lthreshold=INDEF,\
                 hthreshold=INDEF, nlow=1, nhigh=1,\
		 lsigma=rsigma, hsigma=rsigma )
    }
    else
    {
      if( flagu[i] > 0 )
        imcombine( input="@"//tmp_listu[i], output=out_fnu[i],\
	           combine="average",\
                   reject="none", project-, outtype="real",\
                   offsets="none", masktype="none", lthreshold=INDEF,\
                   hthreshold=INDEF, nlow=1, nhigh=1 )
    }
  }

  delete( tmp_list1 )
  for( i=1; i<=16; i+=1 ){
    if( flagl[i] > 1 )
      delete( tmp_listl[i] )
    if( flagu[i] > 1 )
      delete( tmp_listu[i] )
  }

end

